#!/usr/bin/perl
use CGI::Carp qw(fatalsToBrowser);

######################## Program Header #########################################
##
##  Copyright (C) 2003  Poetic Pollution
##  Script Name: ImageShuffler
##  Version: 0.4
##  URL: http://poeticpollution.net/scripts/ImageShuffler/
##
##  This program is free software; you can redistribute it and/or
##  modify it under the terms of the GNU General Public License
##  as published by the Free Software Foundation; either version 2
##  of the License, or (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  Please read the full GNU GPL: http://www.gnu.org/copyleft/gpl.html
##
#################################################################################


######################## User Defined Variables ########################
##  Edit as needed...

## Style sheet URL:
$ISStyles = "http://www.yourdomain.com/ISStyles.css";

## offset from GMT?
## "-8" -> hours behind
## "0" -> GMT
## "8" -> hours ahead
$offSet = "-7";

## use military time?
## "0" -> no
## "1" -> yes
$milTime = 0;


######################## Engage ImageShuffler Log Viewer ########################
##  Don't Edit Below Here Unless You Know How...

open(FILE, "ISDataBase.cgi") || die "Unable to open the \"ImageShuffler DataBase\" for reading..";
chomp(@database = <FILE>);
close(FILE);

## get friendly date/time stamp
&getFriendly;

## set up the webpage
print "Content-type: text/html\n\n";

print qq|<html><head><title>ImageShuffler V0.2 Logs</title>
<link rel=stylesheet type="text/css" href="$ISStyles"></head><body>
<span class="titleText">ImageShuffler V0.2 Logs</span> &#160; <b>Current Date/Time:</b> $friendlyStamp<ul type="square">\n|;

## split database into records
for ($i = 0; $i < @database; $i++) {
($imageName[$i],$hyperlinked[$i],$newWindow[$i],$altTag[$i],$alignTag[$i],$borderTag[$i],$delayTime[$i],$friendlyTime[$i],$lastUsed[$i],$displayCnt[$i]) = split(/````/,$database[$i]);

## print the individual record
print qq|<li><b>Image:</b> $imageName[$i]<br>
<b>Hyperlinked:</b> \n|;
if ($hyperlinked[$i]) { print qq|<a href="$hyperlinked[$i]">$hyperlinked[$i]</a>\n|; }
else { print qq|None\n|;}

print qq| &#160; <b>Opens in</b> |;
if ($newWindow[$i]) { print qq|a new window<br>\n|; }
else { print qq|the current window<br>\n|; }

print qq|<b>Alt parameter:</b> |;
if ($altTag[$i]) { print qq|$altTag[$i]\n|; }
else { print qq|None\n|; }

print qq|<br><b>Alignment:</b> |;
if ($alignTag[$i]) { print qq|$alignTag[$i]\n|; }
else { print qq|None\n|; }

print qq| &#160; <b>Border:</b> $borderTag[$i] &#160; <b>Delay Time:</b> |;
if ($delayTime[$i] eq 'x') { print qq|None<br>\n|; }
else { print qq|$delayTime[$i] hours<br>\n|; }

print qq|<b>Last Shown:</b> $friendlyTime[$i] &#160; <b>Displayed:</b> $displayCnt[$i] time(s)<br><br>\n|;

}
print qq|</ul><a href="http://poeticpollution.net/scripts/ImageShuffler/">Powered by ImageShuffler</a></body></html>|;

exit;


sub getFriendly {
##-----------------------------------------------------

## load the months abbreviations into an array
@months = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);

## load UNIX time into another array
@time = gmtime(time + (3600 * $offSet));

## format the minutes and seconds
$newMinSec = sprintf("%02d:%02d",$time[1],$time[0]);

## format the month's day
$newDay = sprintf("%02d",$time[3]);

## format the year
$years = $time[5] + 1900;

## if you like military time, format the hours that way
if ($milTime) {
	$hours = sprintf("%02d",$time[2]);
}

## if you don't, format it regular like
else {
	if ($time[2] < 12) { if ($time[2] == 0) { $hours = 12; } else { $hours = $time[2]; } $amPm = "AM"; }
	else { if ($time[2] > 12) { $hours = $time[2] - 12; } else { $hours = $time[2]; } $amPm = "PM"; }
}

## now put everything into one variable
$friendlyStamp = "$newDay/$months[$time[4]]/$years at $hours:$newMinSec $amPm";
}
