#!/usr/bin/perl
use CGI::Carp qw(fatalsToBrowser);

######################## Program Header #########################################
##
##  Copyright (C) 2003  Poetic Pollution
##  Script Name: ImageShuffler
##  Version: 0.4
##  URL: http://poeticpollution.net/scripts/ImageShuffler/
##
##  This program is free software; you can redistribute it and/or
##  modify it under the terms of the GNU General Public License
##  as published by the Free Software Foundation; either version 2
##  of the License, or (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  Please read the full GNU GPL: http://www.gnu.org/copyleft/gpl.html
##
#################################################################################


######################## User Defined Variables ########################
##  Edit as needed...

## URL to the directory where the images directories are
## Either a full URL -> Ex: "http://www.yahoo.com/images"
## or a relative URL -> Ex: "/images"
## no trailing slash though!
$imageDir = "/images";

## offset from GMT?
## "-8" -> hours behind
## "0" -> GMT
## "8" -> hours ahead
$offSet = "-7";

## use military time?
## "0" -> no
## "1" -> yes
$milTime = 0;

## make regular backups?
## "0" -> no
## "1" -> yes
$backUps = 0;


######################## Engage ImageShuffler ########################
##  Don't Edit Below Here Unless You Know How...

## initialize the script's variables
$foundIt = 0;
$goodImage = 0;
$timeNow = time;

## open passed image directory variable database
open(FILE, "ISDataBase.cgi") || die "Unable to open the \"ImageShuffler DataBase\" for reading..";
chomp(@database = <FILE>);
close(FILE);

## split database into records
for ($i = 0; $i < @database; $i++) {
	($imageName[$i],$hyperlinked[$i],$newWindow[$i],$altTag[$i],$alignTag[$i],$borderTag[$i],$delayTime[$i],$friendlyTime[$i],$lastUsed[$i],$displayCnt[$i]) = split(/````/,$database[$i]);
}

## loop to find a random image
do {
	## grab a random image from the imageName array
	$randomImage = $imageName[rand(@imageName)];

	## find the random image in the database
	for ($j = 0; $j < @database; $j++) {

		## check if the random image is the current image in the for loop record
		if ($randomImage eq $imageName[$j]) {

			## if delay time isn't needed, set the HTML for the random image
			if ($delayTime[$j] eq 'x') {
				if ($hyperlinked[$j]) {
					if ($newWindow[$j]) {
						$printThis = "<a href=\"$hyperlinked[$j]\" target=_blank><img src=\"$imageDir/$randomImage\" alt=\"$altTag[$j]\" align=\"$alignTag[$j]\" border=\"$borderTag[$j]\"></a>";
					}
					else {
						$printThis = "<a href=\"$hyperlinked[$j]\"><img src=\"$imageDir/$randomImage\" alt=\"$altTag[$j]\" align=\"$alignTag[$j]\" border=\"$borderTag[$j]\"></a>";
					}
				}
				else {
					$printThis = "<img src=\"$imageDir/$randomImage\">";
				}

				## prepare new friendly time stamp and new image display count
				&getFriendly;
				$displayCnt[$j]++;

				## save the new image stats so we'll have it when the image is used again
				$database[$j] = "$imageName[$j]````$hyperlinked[$j]````$newWindow[$j]````$altTag[$j]````$alignTag[$j]````$borderTag[$j]````$delayTime[$j]````$friendlyStamp````$timeNow````$displayCnt[$j]";

				## tell the do loop to stop
				$goodImage = 1;
			}

			## check for ample delay time and set HTML for the random image
			unless ($timeNow < $lastUsed[$j] + ($delayTime[$j] * 3600)) {
				if ($hyperlinked[$j]) {
					$printThis = "<a href=\"$hyperlinked[$j]\"><img src=\"$imageDir/$randomImage\" alt=\"$altTag[$j]\" align=\"$alignTag[$j]\" border=\"$borderTag[$j]\"></a>";
				}
				else {
					$printThis = "<img src=\"$imageDir/$randomImage\" alt=\"$altTag[$j]\" align=\"$alignTag[$j]\" border=\"$borderTag[$j]\">";
				}

				## prepare new friendly time stamp and new image display count
				&getFriendly;
				$displayCnt[$j]++;

				## save the new image stats so we'll have it when the image is used again
				$database[$j] = "$imageName[$j]````$hyperlinked[$j]````$newWindow[$j]````$altTag[$j]````$alignTag[$j]````$borderTag[$j]````$delayTime[$j]````$friendlyStamp````$timeNow````$displayCnt[$j]";

				## tell the do loop to stop
				$goodImage = 1;

				## tell the doloop to stop
				$goodImage = 1;
			}

			## and now we know the image was in the database
			$foundIt = 1;
		}
	}

	## if we didn't find the image in the database after the complete for loop, the script dies..
	unless ($foundIt) {
		die "Random image \"$randomImage\" not found in the database..";
	}

  ## do it all again if we didn't find a random image we can use
} until ($goodImage);

## open and write the new records in the database
open (FILE, ">ISDataBase.cgi") || die "Unable to open the \"ImageShuffler DataBase\" for writing.";
flock (FILE, 2);
foreach $imageRecord (@database) { print FILE qq|$imageRecord\n|; }
close(FILE);

## make a back up if necessary
if ($backUps) {
	open (FILE, ">IMDataBase-bu.cgi") || die "Unable to open the \"ImageShuffler DataBase backup file\" for writing.";
	flock (FILE, 2);
	foreach $imageRecord (@database) { print FILE qq|$imageRecord\n|; }
	close(FILE);
}

## print our random image and we're finally outta here
print "Content-type: text/html\n\n";

print qq|$printThis|;
exit;


sub getFriendly {
##-----------------------------------------------------

## load the months abbreviations into an array
@months = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);

## load UNIX time into another array
@time = gmtime(time + (3600 * $offSet));

## format the minutes and seconds
$newMinSec = sprintf("%02d:%02d",$time[1],$time[0]);

## format the month's day
$newDay = sprintf("%02d",$time[3]);

## format the year
$years = $time[5] + 1900;

## if you like military time, format the hours that way
if ($milTime) {
	$hours = sprintf("%02d",$time[2]);
}

## if you don't, format it regular like
else {
	if ($time[2] < 12) { if ($time[2] == 0) { $hours = 12; } else { $hours = $time[2]; } $amPm = "AM"; }
	else { if ($time[2] > 12) { $hours = $time[2] - 12; } else { $hours = $time[2]; } $amPm = "PM"; }
}

## now put everything into one variable
$friendlyStamp = "$newDay/$months[$time[4]]/$years at $hours:$newMinSec $amPm";
}
